<?php
namespace Teknisa\CRM\Controller;

use Teknisa\CRM\Controller\TeknisaCrud;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO\Request\Filter;

class RelatorioConsolidadoDeLeadsController extends TeknisaCrud {
    
    protected $dataSourceName = 'relatorioConsolidadoDeLeads_lead';
    
    
    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        $filterCriteria = $request->getFilterCriteria();
        $filterConditions = $filterCriteria->getConditions();
        
        $agrupador = $this->findFilterValue($filterConditions, "AGRUPADOR");
        
        // Se o relatório está sendo agrupado por lead
        if($agrupador == "L") {
            $this->dataSourceName = 'relatorioConsolidadoDeLeads_lead';
            
            $filtersToRemove = [
                "AGRUPADOR",
                "IDATIVO",
                "NMCANDIDATO",
                "NMOPERRESP",
                "IDSTATUSCAN",
                "DTINCLUSAO"
            ];
        } else {
            $this->dataSourceName = 'relatorioConsolidadoDeLeads_oper';
            
            $filtersToRemove = [
                "AGRUPADOR",
                "IDATIVO",
                "NMCANDIDATO",
                "NMOPERRESP",
                "IDSTATUSCAN",
                "DTINCLUSAO"
            ];
        }
        
        $filterConditions = $this->removeFilterFromRequest($filterConditions,
            $filtersToRemove);
            
        $newRequest = $this->createNewRequest($request, $filterConditions);
            
        parent::find($newRequest, $response);
    }
    
    public function findFilterValue($filterCriteria, $name) {
        foreach($filterCriteria as $index => $filter) {
            if($filter["columnName"] == $name) {
                return $filter["value"];
            }
        }
    }
    
    public function removeFilterFromRequest($filterConditions, $filtersToRemove) {
        foreach($filterConditions as $index => $condition) {
            
            if(in_array($condition["columnName"], $filtersToRemove)) {
                unset($filterConditions[$index]);
            }
        }
        
        array_values($filterConditions);
        
        return $filterConditions;
    }
    
    public function createNewRequest($oldReq, $filterConditions) {
        $oldCriteria = $oldReq->getFilterCriteria();
        
        $newCriteria = new FilterCriteria($oldCriteria->getDataSourceName(),
                $filterConditions, $oldCriteria->getPage(),
                $oldCriteria->getPageSize());
            
            
        $newReq = new Filter($newCriteria, $oldReq->getMethod(),
            $oldReq->getRoutePath(), $oldReq->getUserId());
            
        return $newReq;
    }
}