<?php
namespace Teknisa\CRM\Controller;

use Teknisa\CRM\Controller\TeknisaCrud;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\Model\Util\NovoCodigo;

class crm00001000ParametrizacaoCrmController extends TeknisaCrud {
    protected $dataSourceName = 'crm_parametrizacao';
    protected $parametrizacaoService;
    
    public function __construct ($crudService, $parameterBag, $parametrizacaoService, $ticketBotController, $CRMParameters){
        
        $this->parametrizacaoService = $parametrizacaoService;
        $this->ticketBotController = $ticketBotController;
        $this->CRMParameters = $CRMParameters;
        
        parent::__construct($crudService, $parameterBag);
        
    }
    
    public function save(Request $request, Response $response) {
        
        $rows =  $request->getDataSet()->getRows();

        /**
         * Verifica se será necessário criptografar o password do IMAP
        */
        $nrorg = (empty($rows[0]['NRORG'])) ? $this->CRMParameters->getNrorg() : $rows[0]['NRORG'];
        if(!empty($rows[0]['TXHOSTIMAP'])){
            $passImap = empty($rows[0]['TXPASSIMAP']) ? '' : $rows[0]['TXPASSIMAP'];
            $oldPassImap = empty($rows[0]['OLDPASSIMAP']) ? '' : $rows[0]['OLDPASSIMAP'];
            if($passImap !== $oldPassImap && !empty($passImap)){
                $rows[0]['TXPASSIMAP'] = \Teknisa\CRM\Util\Util::encrypt($passImap);
            }
            //Cria o job de criação de tickets via email
            $this->ticketBotController->createJobInJenkins($nrorg, $response);
        }else{
            $this->ticketBotController->deleteJobInJenkins($nrorg, $response);
        }
        
        //Cria Modo de Divulgação(Como chegou até nós relacionado ao RD)
        if(!empty($rows[0]['DSTOKENPUBLICORD'])){
            $cdmododivulg = NovoCodigo::geraCodigo($this->CRMParameters->getNrOrg(), "CDMODODIVULG", 1, 5, false, true);
            $params = array(
                'CDMODODIVULG' => $cdmododivulg,
                'NMMODODIVULG' => 'RD Station',
                'NRORG' => $this->CRMParameters->getNrOrg(),
                'CDOPERINCLUSAO' => $this->CRMParameters->getCdOperador(),
            );
            $this->parametrizacaoService->createMododivulg($params);    
        }
        
        parent::save($request, $response);
        
	    $columnsToReturn = $this->crudService->getColumnsToReturn();

        $retorno = array();
        if (count($columnsToReturn) > 0)
            $retorno["NRSEQPARAMETRIZACAO"] = $columnsToReturn[0]["NRSEQPARAMETRIZACAO"];
	    
	    $response->addDataSet(new DataSet("columnsToReturn", $retorno));
    }
    
    public function getCrmParametrization(Request $request, Response $response){
        
        $row = $request->getDataSet()->getRows()[0];
        
        $paramsSelectCrmParametrization = array(
            'NRORG'             => $row['NRORG']
        );
        
        $crmParametrization = $this->parametrizacaoService->callGetCrmParametrization($paramsSelectCrmParametrization);
        $dataSetResponse = new DataSet("DADOS",array("PARAMETRIZACAO" => $crmParametrization));
        
        $response->addDataSet($dataSetResponse);
        
    }
    
}