function ProfileController(templateManager, ScreenService, Utilities, restEngine, General, localStorageEngine){
    
    this.checkUrl = function(widget){
        var parcnegocio = decodeURIComponent(window.location.hash).split('?')[1];
        var data = {};
        if(Util.isEmptyOrBlank(parcnegocio)){
            widget.reload().then(function(){
                this.initCurrentRow();
            }.bind(this));
        }else{
            parcnegocio = parcnegocio.split('=')[1];
            var filter = [
                {
                    "name": "NRPARCNEGOCIO",
                    "operator": "=",
                    "value": parcnegocio
                },
                {
                    "name": "NRORG",
                    "operator": "IS_NOT_NULL",
                }
            ];
            restEngine.post("product#/crud/parcnegocio_comunicaparc", {requestType:"FilterData", filter: filter}).then(function(parceiro){
                var parc = parceiro.dataset.parcnegocio_comunicaparc;
                if(Util.isEmptyOrBlank(parc[0])){
                    ScreenService.showMessage("Erro ao buscar as informações do parceiro. <br/>Contate um administrador.")    
                }else{
                    restEngine.post("product#/crud/operador", {requestType:"FilterData", filter: filter}).then(function(operador){
                        if(Util.isEmptyOrBlank(operador.dataset.operador[0])){
                            widget.currentRow.NMOPERADOR  = parc[0].NMPRINCIPALPARC;
                            widget.currentRow.DSEMAILOPER = parc[0].EMAIL;
                            
                            widget = templateManager.container.getWidget('WDGT_NOVO_OPERADOR');
                            widget.currentRow.NMOPERADOR  = parc[0].NMPRINCIPALPARC;
                            widget.currentRow.DSEMAILOPER = parc[0].EMAIL;
                            widget.currentRow.NRPARCNEGOCIO = parc[0].NRPARCNEGOCIO;
                            widget.currentRow.NRORG = parc[0].NRORG;
                            ScreenService.openPopup(widget);
                        }else{
                            var reload = true;
                            ScreenService.showMessage('Operador já cadastrado. <br/>Você será redirecionado ao dashboard').then(function(){
                                window.location.href = '#/product#dashboard';
                                window.location.reload();
                                reload = false;
                            });
                            setTimeout(function(){
                                if(reload){
                                    window.location.href = '#/product#dashboard';
                                    window.location.reload();
                                }
                            }, 4000);
                        }
                    });
                }
            });
        }   
    };
    
    this.initCurrentRow = function(args) {
        var widget = templateManager.container.getWidget('crm_perfil_form');
        var data   = widget.dataSource.data[0];
        
        widget.currentRow.NMOPERADOR = getLocalVar('CRM_NMOPERADOR')/*data.NMOPERADOR*/;
        widget.currentRow.DSEMAILOPER = getLocalVar('CRM_DSEMAILOPER')/*data.DSEMAILOPER*/;
    };
    
    this.openPopupRedefinirSenha = function(args){
        var widget = templateManager.container.getWidget('crm_perfil_popup');
        ScreenService.openPopup(widget);
    };
    
    this.redefinirSenha = function(widget){
        if(widget.isValid()){
            if(widget.currentRow.NOVA_SENHA === widget.currentRow.CONFIRMAR_SENHA){
                restEngine.post('/redefinirSenha', {'requestType': 'Row', 'row': [widget.currentRow]}).
                    then(function(success){
                        ScreenService.showMessage('Senha Alterada com Sucesso.');
                        widget.currentRow.SENHA_ATUAL     = "";
                        widget.currentRow.NOVA_SENHA      = "";
                        widget.currentRow.CONFIRMAR_SENHA = "";
                        widget.currentRow.NRINSCRICAOPARC = "";
                        ScreenService.closePopup();
                    }).
                    catch(function(error){
                        ScreenService.showMessage(error.data.error);
                        widget.currentRow.SENHA_ATUAL     = "";
                    });
            }else{
                ScreenService.showMessage('As senhas não coincidem');
                widget.currentRow.NOVA_SENHA      = "";
                widget.currentRow.CONFIRMAR_SENHA = "";
            }
        }
        
    };
    
    this.createOper = function(widget){
        if(widget.isValid()){
            if(widget.currentRow.NOVO_NOVA_SENHA === widget.currentRow.NOVO_CONFIRMAR_SENHA){
                widget.currentRow.NRINSCRICAOPARC = widget.currentRow.NRINSCRICAOPARC.replace(/[^0-9]/g, '');
                restEngine.post('/createOper', {'requestType': 'Row', 'row': [widget.currentRow]}).
                    then(function(success){
                        var reload = true;
                        if((success.dataset.OPER[0] && !Util.isEmptyOrBlank(success.dataset.OPER[0].CDOPERADOR)) || !Util.isEmptyOrBlank(success.dataset.OPER.CDOPERADOR)){
                            ScreenService.showMessage('Senha Criada com sucesso. <br/>Você será redirecionado ao dashboard').then(function(){
                                widget.currentRow.SENHA_ATUAL     = "";
                                widget.currentRow.NOVA_SENHA      = "";
                                widget.currentRow.CONFIRMAR_SENHA = "";
                                ScreenService.closePopup();
                                window.location.href = '#/product#dashboard';
                                window.location.reload();
                                reload = false;
                            });
                            setTimeout(function(){
                                if(reload){
                                    window.location.href = '#/product#dashboard';
                                    window.location.reload();
                                }
                            }, 4000);
                        }else{
                            ScreenService.showMessage("Erro no Cadastro. <br/>Contate um administrador.");   
                        }
                    }).
                    catch(function(error){
                        var exceptions = error.data.error.slice(error.data.error.indexOf('ORA'), error.data.error.length);
                        ScreenService.showMessage("Erro no Cadastro. <br/>Contate um administrador informando o trecho abaixo: <br/>"+exceptions);   
                    });
            }else{
                ScreenService.showMessage('As senhas não coincidem');
                widget.currentRow.NOVA_SENHA      = "";
                widget.currentRow.CONFIRMAR_SENHA = "";
            }
        }
        
    };
    this.cancelPopup = function(widget){
        widget.currentRow.SENHA_ATUAL     = "";
        widget.currentRow.NOVA_SENHA      = "";
        widget.currentRow.CONFIRMAR_SENHA = "";
        ScreenService.closePopup();
    };
	
}
Configuration(function(ContextRegister){
    ContextRegister.register('ProfileController', ProfileController);
});